#include <iostream>
#include <fstream>
#include <string>
#include <cmath>
#include <cstring>
#include <stdlib.h>
#include <cstdlib>
#include <stdint.h>
using namespace std;

//format: [-options] [input-file] [output-file]
// Options
//-c  [in][out]; Complile S5 source and print modified source code with line numers, hex offset and compiled hex values
//-h [in][out]; Display help
//-help [in][out];  Display help
//--help [in][out];  Display help

unsigned char read_input_parameters(int param_count, char *param_point[], string& input_source_filename, string& binary_output_filename);

void open_files(string& input_source_filename, string& binary_output_filename, ofstream& source_out_stream, ofstream& binary_out_stream, ifstream& source_in_stream);

void malloc_buffers(char* &bin_buffer, char* &source_buffer, char* &out_buffer, ifstream& source_in_stream, unsigned int &sourcein_stream_lenght);


void compile_file(char* &bin_buffer, char* &source_buffer, char* &out_buffer, ofstream& source_out_stream, ofstream& binary_out_stream, ifstream& source_in_stream, unsigned int &global_charpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned int &outpointer, unsigned int &sourcein_stream_lenght);


void write_files_close(char* &bin_buffer, char* &out_buffer, ofstream& source_out_stream, ofstream& binary_out_stream, unsigned int &global_charpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned int &outpointer);


unsigned short int compile_line( char* &source_buffer, char* &out_buffer, unsigned short int &instr_opcode, unsigned int &global_charpointer,unsigned int &instr_start, unsigned int &line_digitpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned char &instr_opcode_type, unsigned int &sourcein_stream_lenght, unsigned char &end_of_file);

unsigned char get_addr_digit(char* &source_buffer, unsigned int &line_digitpointer, unsigned int &global_charpointer, unsigned char &instr_opcode_type);



main(int param_count, char *param_point[]) {
    
    string input_source_filename;
    string binary_output_filename;
    unsigned char inputopt;
    ifstream source_in_stream;        //source code file => read
    ofstream source_out_stream;         //mod source code file =>write
    ofstream binary_out_stream;            //compiled binary => write
    unsigned int sourcein_stream_lenght;
    
    unsigned int global_charpointer;  //
    unsigned int linecounter;         //counts all lines
    unsigned int codelinecounter;     //counts valid code lines
    unsigned int outpointer;
    
    char* source_buffer;
    char* bin_buffer;
    char* out_buffer;
       
    
    inputopt = read_input_parameters( param_count, param_point, input_source_filename, binary_output_filename );

    //inputopt=100;
    //cout << static_cast<unsigned>(inputopt) << std::endl;
    if (inputopt == 1) {
    cout << "-c" <<endl;
    //return 0;
    }
    else if (inputopt == 100){
    return 0; //help displayed
    }
    else if (inputopt == 110){
    return 0; //no
    }
    else if (inputopt == 120){
    return 0;
    }
    
    open_files(input_source_filename, binary_output_filename, source_out_stream, binary_out_stream, source_in_stream);
    
    malloc_buffers(bin_buffer, source_buffer, out_buffer, source_in_stream, sourcein_stream_lenght);
    
    compile_file(bin_buffer, source_buffer, out_buffer, source_out_stream, binary_out_stream, source_in_stream, global_charpointer, linecounter, codelinecounter, outpointer, sourcein_stream_lenght);
    
    write_files_close(bin_buffer, out_buffer, source_out_stream, binary_out_stream, global_charpointer, linecounter, codelinecounter, outpointer);
    
    //cout << input_source_filename << "     "  << binary_output_filename <<endl <<endl; 
    
return 0; 
}



 
 unsigned char read_input_parameters (int param_count, char *param_point[], string& input_source_filename, string& binary_output_filename ){
    
//  std::cout << "There are " << param_count << " arguments:\n";
//  
// 	// Loop through each argument and print its number and value
// 	for (int count=0; count < param_count; ++count)
// 		std::cout << count << " " << param_point[count] << '\n';
//     
unsigned char inputoption;
   if (param_count<=3) {
     cout <<"Too few input parameters => see -help for input options" << endl;
     inputoption=120;
     return inputoption;  } //dump error message if less than 3 arguments are used
     
     
	
   if (std::string(param_point[1])=="-c") {  
     cout <<"\nComplile S5 source and print modified source code with line numers, hex offset and compiled hex values\n";                                 
     inputoption=1;     } 
   else if (std::string(param_point[1])=="-h" || std::string(param_point[1])=="-help" || std::string(param_point[1])=="--help") {  
     cout <<"\nHelp for Simatic S-010-Compiler/Assember for old Maho milling machine PLC:\n-c [in][out]; Complile S5 source; \n              print modified source code with line numers,\n              hex offset and compiled hex values\n\nInput format:\n[in]: Input Simatic S5-010 source file \n[out]: Compiled binary of Simatic S5-010 source file\n\nExample: s5c -c src.txt out.bin\nCompiles src.txt into out.bin\nUse your favorite hex editor to split out.bin into e.g. 2kbytes parts to program it into EPROMs (bin.out is complete source file) \n\nProgrammed by P.Hinz aka MadTux\n\n" << endl;                        
     inputoption=100;   
     return inputoption;    }
   else {
     cout <<"Unknown/Wrong first input parameter => see -help for input options" << endl;  
     inputoption=110; 
     return inputoption;     } 
     
     std::cout << "Input file:  " << param_point[2] << '\n';
     std::cout << "Input file:  " << param_point[3] << '\n';
     input_source_filename = std::string(param_point[2]);
     binary_output_filename = std::string(param_point[3]);
return inputoption;
}
 
 void open_files( string& input_source_filename, string& binary_output_filename, ofstream& source_out_stream, ofstream& binary_out_stream, ifstream& source_in_stream ){
    int string_size = input_source_filename.size();
    char input_source_filename_mod[string_size+10];
    int a=0;
    int b=0;
    unsigned char dotmarker=0;
    
    for(;a<=(string_size);a++,b++){
        if (input_source_filename[a] =='.' && dotmarker == 0 ){
            input_source_filename_mod[a] = '-';
            input_source_filename_mod[a+1] = 'm';
            input_source_filename_mod[a+2] = 'o';
            input_source_filename_mod[a+3] = 'd';
            b=b+4;
            dotmarker=1;}
            
        input_source_filename_mod[b] = input_source_filename[a];}
        
    if (dotmarker == 0 ){
        input_source_filename_mod[a+3]=input_source_filename[a-1];
        input_source_filename_mod[a-1] = '-';
        input_source_filename_mod[ a ] = 'm';
        input_source_filename_mod[a+1] = 'o';
        input_source_filename_mod[a+2] = 'd';}
        
    string source_mod_filename_mod;
    source_mod_filename_mod= string(input_source_filename_mod);
    
    source_in_stream.open (input_source_filename.c_str(), ios::in|ios::binary|ios::ate);
    source_out_stream.open(source_mod_filename_mod.c_str(), ios::out|ios::binary);
    binary_out_stream.open(binary_output_filename.c_str(), ios::out|ios::binary);
}
 
 
void write_files_close(char* &bin_buffer, char* &out_buffer, ofstream& source_out_stream, ofstream& binary_out_stream, unsigned int &global_charpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned int &outpointer){

   source_out_stream.write(out_buffer, outpointer);
   
   binary_out_stream.write(bin_buffer, (codelinecounter*2));
   
   source_out_stream.close();
   binary_out_stream.close();
}


void malloc_buffers(char* &bin_buffer, char* &source_buffer, char* &out_buffer, ifstream& source_in_stream, unsigned int &sourcein_stream_lenght){
   
    bin_buffer=(char*) malloc(200000);                  //mallocs 200kB memory as binary output buffer
      if (bin_buffer==NULL){ 
      cout <<"Can't malloc binary buffer (100kB memory)" << endl;      //malloc error with message if NULL returned
      }
      
    out_buffer=(char*) malloc(1000000);                  //mallocs 30kb memory to buffer input/output for parsing
      if (out_buffer==NULL){ 
      cout <<"Can't malloc output buffer (1000000kB memory)" << endl;      //malloc error with message if NULL returned
      }         
      
    source_in_stream.seekg(0, source_in_stream.end); //set pointer of source input to zero
    sourcein_stream_lenght = source_in_stream.tellg();
    source_in_stream.seekg (0, source_in_stream.beg);
    cout << "Source file lenght:  " << sourcein_stream_lenght <<endl; 
    
    source_buffer=(char*) malloc(sourcein_stream_lenght);   //mallocs enough memory to buffer the file
      if (source_buffer==NULL){ 
      cout <<"Can't malloc source buffer memory:  " << sourcein_stream_lenght << "bytes"  << endl;    //malloc error with message if NULL returned
      } 
    source_in_stream.read (source_buffer,sourcein_stream_lenght); //fill source buffer with 
    
//     cout << "First 100 chars of source_buffer:  "<<endl;
//     for (int i=0; i<(100);i++){
//         cout<<source_buffer[0+i];  }  
//         cout <<endl;
    }

void compile_file(char* &bin_buffer, char* &source_buffer, char* &out_buffer, ofstream& source_out_stream, ofstream& binary_out_stream, ifstream& source_in_stream, unsigned int &global_charpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned int &outpointer, unsigned int &sourcein_stream_lenght){
    
    unsigned short int instr_opcode;           //16bit instr opcode returned from compile_line
    unsigned int line_digitpointer;
    unsigned char end_of_file;        //set if end of file is reached
    unsigned int instr_start;
    unsigned char instr_opcode_type;
    //instr_opcode_type aaabbbcc
    //aaa= opcode type 000=no opcode; 001=opcode without addr 010=opcode with I/O addr; 011=opcode with flag addr.
    //100=invalid opcode
    //bbb=address type 000=no addr; 001=short addr x.x; 010=long addr xx.x; 
    //100=invalid addr
     //cc=valid code/addr 00=>invalid code&addr; 10=>valid code/invalid addr 01=>invalid code/valid addr 
    
    global_charpointer=0;
    line_digitpointer=0;
    linecounter=0;
    codelinecounter=0;
    end_of_file=0;
    outpointer=0;
    
    char prnt_instr_tmp; 
    char prnt_codelpnter;
    unsigned int codelpnter_inc_1;
    char prnt_hex_ofst;
    unsigned int div10;
    int buffer_high;
    int buffer_low;

    while (end_of_file!=1){
      instr_opcode_type=0;
      linecounter=linecounter+1;
      instr_opcode = compile_line( source_buffer, out_buffer, instr_opcode,  global_charpointer, instr_start, line_digitpointer,  linecounter, codelinecounter, instr_opcode_type, sourcein_stream_lenght, end_of_file);
      
      //if valid instruction is found:
      if ((instr_opcode_type & 0b00000011)==0b00000011){
         bin_buffer[(codelinecounter*2)]   = (instr_opcode & 0xff00) >> 8;
         bin_buffer[(codelinecounter*2)+1] = (instr_opcode & 0x00ff);

         buffer_high = static_cast<int>(bin_buffer[(codelinecounter*2)]);
         buffer_low = static_cast<int>(bin_buffer[(codelinecounter*2)+1]);
         buffer_high = buffer_high & 0x000000ff;
         buffer_low = buffer_low & 0x000000ff;
         cout << std::hex << "Bin Buffer: " << buffer_high << buffer_low << endl;
         
         out_buffer[outpointer]='>';
         out_buffer[outpointer+1]=' ';
         outpointer=outpointer+2;
         
         //print compiled hex values:
         for (int cc=3; cc>=(0); cc--){
            prnt_instr_tmp = (instr_opcode&(0x000f<<(cc*4)))>> cc*4;
            //cout << std::dec << "Temp Char: " << prnt_instr_tmp;
            if (prnt_instr_tmp<=9){
               prnt_instr_tmp=prnt_instr_tmp+48;}
            else if (prnt_instr_tmp<=15){
               prnt_instr_tmp=prnt_instr_tmp+55;}
            //cout << "   Temp Char mod: " << prnt_instr_tmp;
            out_buffer[(outpointer+3)-cc]=prnt_instr_tmp;}
         out_buffer[outpointer+4]=' ';
         outpointer=outpointer+5;
            
         //print valid line numbers:
         div10=10000;
         codelpnter_inc_1=codelinecounter+1;
         
         for (int lnc=4; lnc>=(0); lnc--){
            prnt_codelpnter=codelpnter_inc_1/div10;
            prnt_codelpnter=prnt_codelpnter+48;
            
            out_buffer[(outpointer+4)-lnc]=prnt_codelpnter;
            codelpnter_inc_1=codelpnter_inc_1%div10;
            div10=div10/10;}
            
         out_buffer[outpointer+5]=' ';
         outpointer=outpointer+6;
      
         //print instr hex offset:
         for (int ofsc=4; ofsc>=(0); ofsc--){
            prnt_hex_ofst = ((codelinecounter*2) & (0x0000000f<<(ofsc*4))) >> ofsc*4;
            if (prnt_hex_ofst<=9){
               prnt_hex_ofst=prnt_hex_ofst+48;}
            else if (prnt_hex_ofst<=15){
               prnt_hex_ofst=prnt_hex_ofst+55;}
            out_buffer[(outpointer+4)-ofsc]=prnt_hex_ofst;}
         out_buffer[outpointer+5]=' ';
         outpointer=outpointer+6;
         codelinecounter=codelinecounter+1;
      }
      
      //if invalid instr is found:
      else if((instr_opcode_type & 0b00000011)==0b00000000){
         out_buffer[outpointer]='x';
         out_buffer[outpointer+1]=' ';
         outpointer=outpointer+2;
         
         //char space for compiled hex values
         for (int ofs1=0; ofs1<=(4); ofs1++){
            out_buffer[outpointer+ofs1]=' ';}
         outpointer=outpointer+5;
         
         //char space for line numbers
         for (int ofs2=0; ofs2<=(6); ofs2++){
            out_buffer[outpointer+ofs2]=' ';}
         outpointer=outpointer+6;
         
         //char space for instr hex offset
         for (int ofs2=0; ofs2<=(6); ofs2++){
            out_buffer[outpointer+ofs2]=' ';}
         outpointer=outpointer+6;
      }
            
      //print instructions:
      //cout << std::dec << "global_charpointer: " << global_charpointer<< endl;
      for(int instrcharcnt=instr_start; instrcharcnt<=global_charpointer-1; instrcharcnt = instrcharcnt+1){
         out_buffer[outpointer]=source_buffer[instrcharcnt];
         //cout << std::dec << "instrcharcnt: " << instrcharcnt << "  char: " << out_buffer[outpointer] << endl;
         outpointer=outpointer+1;}
    } //end of while loop
    //bin_buffer[(codelinecounter*2)]   = 0x65; Write block end, no matter what end the source has 
    //bin_buffer[(codelinecounter*2)+1] = 0x00;
         
    cout << std::dec << "Bin out buffer:  "<< codelinecounter*2 <<" bytes; " << codelinecounter << " 2-byte wide instructions"<<endl;
    for (int i=0; i<=codelinecounter;i=i+1){
       
       buffer_high = static_cast<int>(bin_buffer[(i*2)]);
       buffer_low = static_cast<int>(bin_buffer[(i*2)+1]);
       buffer_high = buffer_high & 0x000000ff;
       buffer_low = buffer_low & 0x000000ff;
       std::cout.fill ('0');
       std::cout.width (2);
       cout << std::hex  << buffer_high;
       std::cout.fill ('0');
       std::cout.width (2);
       cout << std::hex << buffer_low <<" ";}
       cout<<endl;
   
    cout << std::dec << "Output buffer:  "<< outpointer <<" bytes" <<endl;
    for (int i=0; i<=outpointer;i++){
        cout<<out_buffer[0+i];}
   cout << endl;
   cout << std::dec << "Input charpointer @ end of file:     " << global_charpointer<< endl;
   cout << std::dec << "Output charpointer @ end of file:    " << outpointer << endl;
   cout << std::dec << "Binary output pointer @ end of file: " << codelinecounter << endl;
}


unsigned short int compile_line(char* &source_buffer, char* &out_buffer,  unsigned short int &instr_opcode,  unsigned int &global_charpointer,unsigned int &instr_start, unsigned int &line_digitpointer, unsigned int &linecounter, unsigned int &codelinecounter, unsigned char &instr_opcode_type, unsigned int &sourcein_stream_lenght, unsigned char &end_of_file){
//     cout << "First 100 chars of source_buffer:  "<<endl;
//     for (int i=0; i<(100);i++){
//         cout<<source_buffer[0+i];}
    
    unsigned char addr_digit1;
    unsigned char addr_digit2;
    unsigned char addr_digit3; 
    unsigned char addr_digit4; 
    unsigned short int addr_block;  //Addr: xx.y  xx=>addr_block y=>subblock
    unsigned short int addr_subblock;
    unsigned int addr_digitcounter;         //counts digits
    addr_digitcounter=0;
    instr_start=global_charpointer;
    //cout <<"Source stream lenght: "<< sourcein_stream_lenght << endl;
    //cout <<"Global charpointer: "<< global_charpointer << endl;
    
    parseline:
    for(int lc=0; lc<(10000);lc++){                        //linelenght probably is less than 10k char, i is charpointer within line
    // cout << "linecounter: " << lc << " - char counter: "<< global_charpointer<<endl;
    if (sourcein_stream_lenght<=global_charpointer){
        end_of_file=1; 
        cout << "Reached end of file!" <<endl; 
        break;}
    //cout << "loop#: "<< lc <<endl; 
   
    
      if (source_buffer[global_charpointer+lc]=='\n'){          //cout << "newline found" <<endl;
          global_charpointer=global_charpointer+lc+1;
          linecounter=linecounter+1;
          //cout << "Newline found" <<endl; 
          break;}  //break to compile only one line, 
          
      //if ((instr_opcode_type&0b00000010)==0){
      if (source_buffer[global_charpointer+lc]=='U'){          //cout << "U found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='E'){
            instr_opcode=0xC000;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "UE found" <<endl; 
            instr_opcode_type=instr_opcode_type|0b01000010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]=='A'){
            instr_opcode=0xC080;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "UA found" <<endl; 
            instr_opcode_type=instr_opcode_type|0b01000010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]=='M'){
            instr_opcode=0x8000;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "UM found" <<endl;
            instr_opcode_type=instr_opcode_type|0b01100010;
            instr_start=global_charpointer+lc;
            break;}
            if(source_buffer[global_charpointer+lc+sc]=='N'){
              for(int sd=1; sd<(20);sd++){
                 if(source_buffer[global_charpointer+lc+sc+sd]=='E'){
                   instr_opcode=0xE000;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "UNE found" <<endl; 
                   instr_opcode_type=instr_opcode_type|0b01000010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]=='A'){
                   instr_opcode=0xE080;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "UNA found" <<endl; 
                   instr_opcode_type=instr_opcode_type|0b01000010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]=='M'){
                   instr_opcode=0xA000;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "UNM found" <<endl; 
                   instr_opcode_type=instr_opcode_type|0b01100010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]!=' '){ //break if any other char is found
                   break;}}}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}       }}
      
      if (source_buffer[global_charpointer+lc]=='O'){
          //cout << "U found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='E'){
           instr_opcode=0xC800;
           line_digitpointer=global_charpointer+lc+sc+1;
           cout << "OE found" <<endl;
           instr_opcode_type=instr_opcode_type|0b01000010;
           instr_start=global_charpointer+lc;
           break;}
          if(source_buffer[global_charpointer+lc+sc]=='A'){
           instr_opcode=0xC880;
           line_digitpointer=global_charpointer+lc+sc+1;
           cout << "OA found" <<endl; 
           instr_opcode_type=instr_opcode_type|0b01000010;
           instr_start=global_charpointer+lc;
           break;}
          if(source_buffer[global_charpointer+lc+sc]=='M'){
           instr_opcode=0x8800;
           line_digitpointer=global_charpointer+lc+sc+1;
           cout << "OM found" <<endl; 
           instr_opcode_type=instr_opcode_type|0b01100010;
           instr_start=global_charpointer+lc;
           break;}
            if(source_buffer[global_charpointer+lc+sc]=='N'){
              for(int sd=1; sd<(20);sd++){
                 if(source_buffer[global_charpointer+lc+sc+sd]=='E'){
                   instr_opcode=0xE800;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "ONE found" <<endl;
                   instr_opcode_type=instr_opcode_type|0b01000010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]=='A'){
                   instr_opcode=0xE880;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "ONA found" <<endl;
                   instr_opcode_type=instr_opcode_type|0b01000010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]=='M'){
                   instr_opcode=0xA800;
                   line_digitpointer=global_charpointer+lc+sc+sd+1;
                   cout << "ONM found" <<endl;
                   instr_opcode_type=instr_opcode_type|0b01100010;
                   instr_start=global_charpointer+lc;
                   break;}
                 if(source_buffer[global_charpointer+lc+sc+sd]!=' '){ //break if any other char is found
                   break;}}}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}       }}
    
      if (source_buffer[global_charpointer+lc]=='S'){
          //cout << "S found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='A'){
            instr_opcode=0xD080;
            instr_start=global_charpointer+lc;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "SA found" <<endl;
            instr_opcode_type=instr_opcode_type|0b01000010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]=='M'){
            instr_opcode=0x9000;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "SM found" <<endl;
            instr_opcode_type=instr_opcode_type|0b01100010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}        }}

      if (source_buffer[global_charpointer+lc]=='R'){
          //cout << "S found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='A'){
            instr_opcode=0xF080;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "RA found" <<endl;
            instr_opcode_type=instr_opcode_type|0b01000010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]=='M'){
            instr_opcode=0xB000;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "RM found" <<endl; 
            instr_opcode_type=instr_opcode_type|0b01100010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}        }}
        
      if (source_buffer[global_charpointer+lc]=='='){
          //cout << "S found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='A'){
            instr_opcode=0xD880;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "=A found" <<endl;
            instr_opcode_type=instr_opcode_type|0b01000010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]=='M'){
            instr_opcode=0x9800;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "=M found" <<endl; 
            instr_opcode_type=instr_opcode_type|0b01100010;
            instr_start=global_charpointer+lc;
            break;}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}        }}
        
      if (source_buffer[global_charpointer+lc]=='N'){
          //cout << "S found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='O'){
            for(int sd=1; sd<(20);sd++){
                 if(source_buffer[global_charpointer+lc+sc+sd]=='P'){
                   for(int se=1; se<(20);se++){
                    if(source_buffer[global_charpointer+lc+sc+sd+se]=='0'){
                     instr_opcode=0x0000;
                     line_digitpointer=global_charpointer+lc+sc+sd+se+1;
                     cout << "NOP0 found" <<endl; 
                     instr_opcode_type=instr_opcode_type|0b00100010;
                     instr_start=global_charpointer+lc;
                     break;}
                    if(source_buffer[global_charpointer+lc+sc+sd+se]=='1'){
                     instr_opcode=0xFFFF;
                     line_digitpointer=global_charpointer+lc+sc+sd+se+1;
                     cout << "NOP1 found" <<endl; 
                     instr_opcode_type=instr_opcode_type|0b00100010;
                     instr_start=global_charpointer+lc;
                     break;}
                    if(source_buffer[global_charpointer+lc+sc+sd+se]!=' '){ //break if any other char is found
                     break;}}}
             if(source_buffer[global_charpointer+lc+sc+sd]!=' '){ //break if any other char is found
                   break;}}}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}}}
        
      if (source_buffer[global_charpointer+lc]=='B'){
          //cout << "U found" <<endl;
        for(int sc=1; sc<(20);sc++){
          if(source_buffer[global_charpointer+lc+sc]=='E'){
            for(int sd=1; sd<(20);sd++){
             if(source_buffer[global_charpointer+lc+sc+sd]=='B'){
               instr_opcode=0x0500;
               line_digitpointer=global_charpointer+lc+sc+sd+1;
               cout << "BEB found" <<endl;
               instr_opcode_type=instr_opcode_type|0b00100010;
               instr_start=global_charpointer+lc;}
             if(source_buffer[global_charpointer+lc+sc+sd]!=' '){ //break if any other char is found
               break;}}
          //cout << "source_buffer[global_charpointer+lc+sc]:  "<<source_buffer[global_charpointer+lc+sc]<<endl;
          if(source_buffer[global_charpointer+lc+sc]=='E' && instr_opcode_type==0){
            instr_opcode=0x6500;
            line_digitpointer=global_charpointer+lc+sc+1;
            cout << "BE found" <<endl;
            instr_opcode_type=instr_opcode_type|0b00100010;
            instr_start=global_charpointer+lc;
            break;}}
          if(source_buffer[global_charpointer+lc+sc]!=' '){ //break if any other char is found
            break;}}}
        } //}
        
//   cout << "Chars at instr_start:";
//     for (int i=0; i<(20);i++){
//     cout<<source_buffer[i+instr_start];  }  
//     cout <<endl;
//     cout << "Instr Opcode Type: " << static_cast<unsigned>(instr_opcode_type) <<endl;
    
    
  if((instr_opcode_type & 0b11100000) == 0b00100000 && end_of_file==0){
    instr_opcode_type=instr_opcode_type|0b00000011;  
    cout << "Instruction without address" <<endl;
    cout << "Instr opcode: ";
    std::cout.fill ('0');
    std::cout.width (4);
    std::cout << std::hex << instr_opcode << endl << endl;
    return instr_opcode;}
      
  if(((instr_opcode_type & 0b11100000) == 0b01000000 || (instr_opcode_type & 0b11100000) == 0b01100000) && end_of_file==0){
    
    //cout << "Global charpointer: "<< global_charpointer << endl; 
    addr_digit1 = get_addr_digit(source_buffer, line_digitpointer, global_charpointer, instr_opcode_type);
    //cout << "Digit-1 pointer: "<< line_digitpointer;
    
    addr_digit2 = get_addr_digit(source_buffer, line_digitpointer, global_charpointer, instr_opcode_type);
    //cout << "Digit-2 pointer: "<< line_digitpointer;
    
    addr_digit3 = get_addr_digit(source_buffer, line_digitpointer, global_charpointer, instr_opcode_type);
    //cout << "Digit-3 pointer: "<< line_digitpointer;
    
    addr_digit4 = get_addr_digit(source_buffer, line_digitpointer, global_charpointer, instr_opcode_type);
    //cout << "Digit-4 pointer: "<< line_digitpointer;
    
    cout << std::dec <<"  Digit-1: " << static_cast<unsigned>(addr_digit1) << endl;
    cout << std::dec <<"  Digit-2: " << static_cast<unsigned>(addr_digit2) << endl;
    cout << std::dec <<"  Digit-3: " << static_cast<unsigned>(addr_digit3) << endl;
    cout << std::dec <<"  Digit-4: " << static_cast<unsigned>(addr_digit4) << endl;
    
    cout << "digits: " << static_cast<unsigned>(addr_digit1) << " " << static_cast<unsigned>(addr_digit2) << " " <<  static_cast<unsigned>(addr_digit3) << " " <<  static_cast<unsigned>(addr_digit4);  
        
    addr_block=0;
    addr_subblock=0;
    
    if((addr_digit1>=0 && addr_digit1<=9) && (addr_digit2>=0 && addr_digit2<=9) && (addr_digit3==20) && (addr_digit4>=0 && addr_digit4<=9)){
      cout << " => long address" <<endl;
      addr_block=(addr_digit1*10)+addr_digit2;
      addr_subblock=addr_digit4;
      instr_opcode_type=instr_opcode_type|0b00001011;  }
    
    else if((addr_digit1>=0 && addr_digit1<=9) && (addr_digit2==20) && (addr_digit3>=0 && addr_digit3<=9)){
      cout << " => short address" <<endl;
      addr_block=addr_digit1;
      addr_subblock=addr_digit3;
      instr_opcode_type=instr_opcode_type|0b00000111;  }
   
    else{
      cout << " => invalid address" <<endl;}

      //cout << "getaddr digits complete" <<endl;
      cout <<"Addr Block: "<< static_cast<unsigned>(addr_block) << "  Addr Subblock: " << static_cast<unsigned>(addr_subblock) <<"; ==> " << static_cast<unsigned>(addr_block)<<"."<< static_cast<unsigned>(addr_subblock)<< endl;
    
      cout << "Instr opcode: ";
      std::cout.fill ('0');
      std::cout.width (4);
      std::cout << std::hex << instr_opcode;
    
      instr_opcode=instr_opcode|addr_block;
      addr_subblock=addr_subblock<<8; //8 bit rightshift of addr_subblock
      instr_opcode=instr_opcode|addr_subblock;
    
      cout << "    Complete opcode: ";
      std::cout.fill ('0');
      std::cout.width (4);
      std::cout << std::hex << instr_opcode << std::endl <<endl;
      return instr_opcode;   }
 }


 
unsigned char get_addr_digit(char* &source_buffer, unsigned int &line_digitpointer, unsigned int &global_charpointer,  unsigned char &instr_opcode_type){
    unsigned char digit;
//     cout << "Chars at digit-pointer:";
//           for (int i=0; i<(20);i++){
//           cout<<source_buffer[i+line_digitpointer];  }  
//           cout <<endl;
//
// digits: 0-9 => good value; 20=>dot; 30=>space; 40=>invalid character; 50=>end of line/out of digtits; 60=>no char found; 
    
    
    digit=60;
    for(int ac=0; ac<(100);ac++){ 
//         cout << "getdigit_loop ac: "<< ac << "; line digitpointer: " << line_digitpointer << "; global charpointer: " << global_charpointer << endl;
        if (line_digitpointer >= global_charpointer){ 
            digit=50; //code for out of digtits
            break;}
            
        if (source_buffer[line_digitpointer+ac]=='\n'){          //cout << "newline found" <<endl;
          instr_opcode_type=100; //code for missing addr or no addr at all
          line_digitpointer=line_digitpointer+1+ac;
          digit=50; //code for out of digtits or end of line
          //cout << "error: digit is newline" <<endl; 
          break;}                                       //break to compile only one line, 
          
        if (source_buffer[line_digitpointer+ac]=='0'){
            //cout << "digit=0" <<endl; 
            digit=0;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='1'){
            //cout << "digit=1" <<endl;  
            digit=1;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='2'){
            //cout << "digit=2" <<endl;  
            digit=2;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='3'){
            //cout << "digit=3" <<endl;  
            digit=3;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='4'){
            //cout << "digit=4" <<endl;  
            digit=4;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='5'){
            //cout << "digit=5" <<endl;  
            digit=5;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='6'){
            //cout << "digit=6" <<endl;  
            digit=6;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='7'){
            //cout << "digit=7" <<endl;  
            digit=7;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='8'){
            //cout << "digit=8" <<endl;  
            digit=8;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='9'){
            //cout << "digit=9" <<endl;  
            digit=9;
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        if (source_buffer[line_digitpointer+ac]=='.'){
            digit=20;
            //cout << "digit=." <<endl; 
            line_digitpointer=line_digitpointer+ac+1;
            break;}
        //space, tab and file seperator
        if (source_buffer[line_digitpointer+ac]==' ' || source_buffer[line_digitpointer+ac]==9 || source_buffer[line_digitpointer+ac]==28){ 
            //cout << "digit=space" <<endl;
            digit=30;}
        //anything else than a space, tab or file seperator
        if (source_buffer[line_digitpointer+ac]!=' ' && source_buffer[line_digitpointer+ac]!=9 && source_buffer[line_digitpointer+ac]!=28){
            digit=40;
            //cout << "error: unknown digit" <<endl; 
            line_digitpointer=line_digitpointer+ac+1;
            break;}

        }
    return digit;
        

    }
    
        
        


// Instructions: DE-Instr/US-Instr/Opcode/OR-Opcode/Description
//
// UE   AI   11000xxx'0xxxxxx 0xC000 AND-Input
// OE   OI   11001xxx'0xxxxxx 0xC800 OR-Input
// UNE  ANI  11100xxx'0xxxxxx 0xE000 Inverted-AND-Input
// ONE  ONI  11101xxx'0xxxxxx 0xE800 Inverted-OR-Input
// 
// UA   AQ   11000xxx'1xxxxxx 0xC080 AND-Output
// OA   OQ   11001xxx'1xxxxxx 0xC880 OR-Output
// UNA  ANQ  11100xxx'1xxxxxx 0xE080 Inverted-AND-Output
// ONA  ONQ  11101xxx'1xxxxxx 0xE880 Inverted-OR-Output
// 
// UM   AF   10000xxx'0xxxxxx 0x8000 AND-Flags
// OM   OF   10001xxx'0xxxxxx 0x8800 OR-Flags
// UNM  ANF  10100xxx'0xxxxxx 0xA000 Inverted-AND-Flags
// ONM  ONF  10101xxx'0xxxxxx 0xA800 Inverted-OR-Flags
// 
// SA   SQ   11010xxx'1xxxxxx 0xD080 Set-Output=>1
// RA   RQ   11110xxx'1xxxxxx 0xF080 Reset-Output=>0   
// =A   =Q   11011xxx'1xxxxxx 0xD880 Store-Result-in-Output
// 
// SM   SF   10010xxx'0xxxxxx 0x9000 Set-Flag=>1
// RM   RF   10110xxx'0xxxxxx 0xB000 Reset-Flag=>1
// =M   =F   10011xxx'0xxxxxx 0x9800 Store-Result-in-Output
// 
// UM00 AF   10000000'0000000 0x8000 Interrupt-Scan
// NOP1 NOP1 11111111'1111111 0xFFFF No-Operation1
// NOP0 NOP0 00000000'0000000 0x0000 No-Operation0
// BE   BE   01100101'0000000 0x6500 Block-End=>Jump-to-Start
// BEB  BEC  00000101'0000000 0x0500 Conditional-Block-End=>Jump-to-Start
// 
// 
// German decoder chain:
// U: UE; UNE; UA; UNA; UM; UNM; UM00;
//     -UE
//     -UNE; UNA; UNM
//     -UA
//     -UM; UM00;
// O: OE; ONE; OA; ONA; OM; ONM;
//     -OE;
//     -ONE; ONA; ONM;
//     -OA;
//     -OM;
// S: SA; SM;
// R: RM; RA;
// =: =A; =M; 
// N: NOP0; NOP1;
// B: BE; BEB;
//
//
// UNA 22.0 => E0 96 => 1110 0000 1001 0110
//                     xxxx xAAA xbbb bbbb
// AAA => inner block addr =0 bbb is block addr, 22 in binary => 0010110
// 
// =M 89.1 => 99 59 => 1001 1001 0101 1001
//                     xxxx xAAA xbbb bbbb
// AAA => inner block addr =1 bbb is block addr, 89 in binary => 1011001
// 
// Decoder scans one line for one valid instruction (with space seperation)
// Linecounter is incremented, if valid instr. is found
// Returns linenumer, instruction type, 

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 































